<template>
  <div class="container">
    <div id="pwpg" class="pwpg" ref="pwpg"></div>
    <HxianPgd id="pwpgd" ref="pwpgd" @loadPdf="loadPdf" @initPgd="initPgd" :worker="getWorker" :workers="workers" />
    <ZyjhSelectComp id="selectComp" ref="selRef"  @initWorkers="initWorkers"/>
    <div id="pdf" class="pdf" :style="{height:height,overflowY:'auto'}" v-if="pdfShow">
      <pdf ref="pdfRef" v-for="i in numPages" :key="i" :page="i" :src="pdfUrl" />
    </div>
    <TipsComp />
    <Drawer ref="drawer"/>
  </div>
</template>

<script>
import container from "./comps/container";
import drawTitle from './comps/title'
import workers from "./comps/person";
import drawDw from './comps/dw'
import drawPgd from './comps/pgd'
import {getForeman, getYcldw} from "@/api/zyjh";
import HxianPgd from "@/views/zyjhzx/hxianpgong/comps/HxianPgd.vue";
import ZyjhSelectComp from "@/views/zyjhzx/components/SelectComp.vue";
import TipsComp from "@/views/zyjhzx/components/TipsComp.vue";
import Drawer from "@/views/zyjhzx/components/Drawer.vue";
import pdf from "vue-pdf";

export default {
  name:'HxianPGong',
  components: {Drawer, TipsComp, ZyjhSelectComp, HxianPgd,pdf},
  data(){
    return {
      title:'划 线 作 业 派 工',
      width:0,
      height:0,
      stage:null,
      layer:null,
      pgdGroup:null,
      drawGd:null,
      getCurrentWorker:null,
      workers:null,
      workerGroup:null,
      zyq:null,
      deviceId:null,
      person:null,
      pdfShow:false,
      pdfUrl:null,
      numPages:null,
    }
  },
  mounted() {
    this.$socket.open()
    this.wsSubscribe()
    this.initKonvaStage();
  },
  created(){
    this.zyq=this.$route.query.zyq
    this.deviceId=this.$route.query.deviceId||''
    // window.addEventListener('resize', this.initKonvaStage)
  },
  sockets:{},
  methods:{
    loadPdf(url){
      if (this.pdfShow){
        this.pdfShow=false
      }
      this.pdfUrl=pdf.createLoadingTask(url)
      this.pdfUrl.promise.then((pdf) => {
        this.numPages = pdf.numPages;
        this.pdfShow=true
      });
    },
    wsSubscribe(){
      // this.sockets.subscribe('zyjhzx', data => {
      //   const currentWorker=this.getCurrentWorker()
      //   if (!currentWorker){
      //     this.$message.error(`未选择指派人员`)
      //     return;
      //   }
      //   if (this.zt===data.zt){
      //     const tmpArr=[{
      //       id:data.zyjh.id,
      //       pwry:currentWorker.userCode
      //     }]
      //     this.$refs.pwpgd.paigong0(tmpArr)
      //   }else{
      //     this.$message.error(`工单号错误:${data.gdh}`)
      //   }
      // })
    },
    initPgd(pgd={}){
      const group=this.drawGd(pgd)
      this.pgdGroup.add(group)
    },
    initDw(){
      getYcldw({type:'llj'}).then(res=>{
        const {container,dw}=drawDw(this.width,this.height)
        const {bgGroup,group}=container()
        this.layer.add(bgGroup)

        for (let i=0;i<res.data.length;i++){
          const item=res.data[i]
          const dwGroup=dw(i,item)
          group.add(dwGroup)
        }
      })
    },
    getWorker(){
      return this.getCurrentWorker()
    },
    initWorkers(bzType){
      if (this.workerGroup){
        this.workerGroup.destroyChildren()
      }else{
        const {container,person,getCurrentWorker}=workers(this.width,this.height)
        this.getCurrentWorker=getCurrentWorker
        this.person=person
        const {layer,group}=container()
        this.workerGroup=group
        this.stage.add(layer)
      }
      this.workerGroup.x(0)
      this.workerGroup.y(0)
      getForeman({zyq:this.zyq}).then(res => {
        this.workers=res.data
        this.$refs.pwpgd.setWorkers(this.workers)
        for (let i=0;i<res.data.length;i++){
          const item=res.data[i]
          item.userName="班组长:"+item.userName
          const worker=this.person(i,item)
          this.workerGroup.add(worker)
        }
      })
      // getBzryList({zyq:this.$route.query.zyq,zt:bzType}).then(res=>{
      //   this.workers=res.data
      //   this.$refs.pwpgd.setWorkers(this.workers)
      //   for (let i=0;i<res.data.length;i++){
      //     const item=res.data[i]
      //     const worker=this.person(i,item)
      //     this.workerGroup.add(worker)
      //   }
      // })
    },
    initKonvaStage(){
      this.width=this.$refs.pwpg.clientWidth
      this.height=this.$refs.pwpg.clientHeight
      const {stage,layer}=container(this.width,this.height,'pwpg')
      this.stage=stage
      this.layer=layer

      const titel=drawTitle(this.width,this.height,this.title)
      const that=this
      titel.on('click tap',function (){
        console.log(111)
        that.$refs.drawer.show()
      })
      this.layer.add(titel)

      this.initWorkers(this.$refs.selRef.getData().bzType)

      this.initDw()

      const {container:pgdContainer,drawGd}=drawPgd(this.width,this.height)
      this.drawGd=drawGd
      this.pgdGroup=pgdContainer()
      this.layer.add(this.pgdGroup)
    },

  }
}

</script>

<style>
#pdf {
  width:28.8%;
  height: 93.5vh;
  position: absolute;
  top:50px;
  right:2.5%;
  border: none;
  margin: 0;
}

#selectComp {
  width:50%;
  height: auto;
  position: absolute;
  top:10px;
  left:20px;
  border: none;
  margin: 0;
}

#pwpgd {
  width:50%;
  height: auto;
  position: absolute;
  top:195px;
  left:20px;
  border: none;
  margin: 0;
}

#pwpg {
  overflow: hidden;
  width: 100%;
  height: 100vh;
  aspect-ratio: 16/9;
}

.container{
  background: #ddd;
}
</style>
